#
#   Twisted Pynfo - A relay, info, and search bot for IRC.
#   Copyright (C) 2002 Jp Calderone (exarkun@twistedmatrix.com)
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111 USA
#

from Crypto.PublicKey import RSA
from Crypto.Util import randpool

randsource = randpool.RandomPool().get_bytes

def secure_REGENERATE(bot, user, channel, args):
    """Usage: regenerate <bits> - Create a new key"""
    try:
        bits = int(args)
    except ValueError:
        bot.reply(channel, "That is not a valid bit count.")
    else:
        bot.factory.data['key'] = RSA.generate(bits, randsource)
        bot.reply(channel, "Generated new %d bit key" % (bits,))
