#
#   Twisted Pynfo - A relay, info, and search bot for IRC.
#   Copyright (C) 2002 Jp Calderone (exarkun@twistedmatrix.com)
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111 USA
#

import sys, re

FORMAT = 'Shorter URL: %s'
THRESH = 60

def _urlMatcher():
    return re.compile(r'\w+://\S+')

#    punct_pattern = re.escape('''"'}]|:,.)?!''')
#    url_schemas = []
#    attachment_schemas = ["attachment", "inline", "drawing"]
#    url_pattern = (
#        'http|https|ftp|nntp|news|mailto|telnet|wiki|file|' +
#        '|'.join(attachment_schemas + url_schemas)
#    )
#    url_rule = r'%(url_guard)s(%(url)s)\:([^\s\<%(punct)s]|([%(punct)s][^\s\<%(punct)s]))+' % {
#        'url_guard': ('(^|(?<!\w))', '')[sys.version < "2"],
#        'url': url_pattern,
#        'punct': punct_pattern,
#    }
#    return re.compile(url_rule)

url_re = _urlMatcher()
def filter_SHORTEN(bot, user, channel, line):
    for url in url_re.findall(line):
        if len(url) <= THRESH:
            continue
        key = str(len(bot.factory.shortenMap) + 1)
        bot.factory.shortenMap[key] = url
        if not bot.factory.webhost:
            continue
        bot.reply(
            channel,
            FORMAT % (
                "http://l.%s:%d/%s" % (
                    bot.factory.webhost,
                    bot.factory.webport,
                    key
                )
            )
        )
